package tech.nevets.dliteserver;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

public class Connection implements Runnable {
    private InputStream is;
    private OutputStream os;
    private MessageDistributer md;
    private String username;

    public Connection(Socket s, MessageDistributer md) throws IOException {
        this.is = s.getInputStream();
        this.os = s.getOutputStream();
        this.md = md;
        String buf = "";
        for (int i = is.read(); (char) i != '\n' && i != -1; i = is.read()) {
            buf += (char) i;
        }
        username = buf;
    }

    @Override
    public void run() {
        try {
            md.registerStream(username, os);
            is.transferTo(md);
        } catch (IOException e) {
            System.out.println("Connection Disconnected");
        }
        MessageDistributer.closeUserConnection(username);
    }
}
