package tech.nevets.dliteserver;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;

public class MessageDistributer extends OutputStream {
    private static Map<String, OutputStream> userStreams = new HashMap<>();

    private String buf = "";

    @Override
    public void write(int b) throws IOException {
        buf += (char) b;
        if (((char) b) == '\n') this.flush();
    }

    @Override
    public void flush() {
        for (OutputStream os : userStreams.values()) {
            try {
                os.write(buf.getBytes(StandardCharsets.UTF_8));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        buf = "";
    }

    public void registerStream(String username, OutputStream os) {
        userStreams.put(username, os);
        try {
            this.write(("SERVER> Welcome, " + username + "!\n").getBytes(StandardCharsets.UTF_8));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void closeUserConnection(String username) {
        userStreams.remove(username);
    }
}
