package tech.nevets.dliteserver;

import javax.net.ssl.*;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.KeyStore;
import java.security.SecureRandom;

public class Server {
    private static SSLServerSocket ss;

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            args = new String[]{"6969"};
        }

        MessageDistributer md = new MessageDistributer();

        KeyStore keyStore = KeyStore.getInstance(KeyStore.getDefaultType());
        InputStream kStore = new FileInputStream("./keystore.p12");
        keyStore.load(kStore, "".toCharArray());
        KeyManagerFactory kmf = KeyManagerFactory.getInstance(KeyManagerFactory.getDefaultAlgorithm());
        kmf.init(keyStore, "".toCharArray());

        SSLContext ctx = SSLContext.getInstance("TLS");
        ctx.init(kmf.getKeyManagers(), null, SecureRandom.getInstanceStrong());

        SSLServerSocketFactory factory = ctx.getServerSocketFactory();
        ss = (SSLServerSocket) factory.createServerSocket(Integer.parseInt(args[0]));
        ss.setNeedClientAuth(false);
        ss.setEnabledProtocols(new String[]{"TLSv1.1", "TLSv1.2", "TLSv1.3"});

        while (true) {
            try {
                new Thread(new Connection(ss.accept(), md)).start();
            } catch (IOException e) {
                System.out.println("User disconnected");
            }
        }
    }
}
